var TZAdmin = window.TZAdmin || {};

!function ($) {

	$.extend(TZAdmin, {
		initBuildLessBtn: function(){
			//recompile
			$('#tz-toolbar-recompile').on('click', function(){
                if (!TZAdmin.devmode) {
                    alert('Please enable Development Mode first!');
                    return false;
                }
				var jrecompile = $(this);

				jrecompile.addClass('loading');
				$.get(TZAdmin.adminurl, {'tzaction': 'lesscall'}, function(rsp){
					jrecompile.removeClass('loading');

					rsp = $.trim(rsp);
					if(rsp){
						var json = rsp;
						if(rsp.charAt(0) != '[' && rsp.charAt(0) != '{'){
							json = rsp.match(/{.*?}/);
							if(json && json[0]){
								json = json[0];
							}
						}

						if(json && typeof json == 'string'){
							json = $.parseJSON(json);

							if(json && (json.error || json.successful)){
								TZAdmin.systemMessage(json.error || json.successful);
							}
						}
					}
				});
				return false;
			});

            //tz added
            $('#tz-toolbar-recompress').on('click', function(){
                if (!TZAdmin.devmode) {
                    alert('Please enable Development Mode first!');
                    return false;
                }
                var jrecompress = $(this);

                jrecompress.addClass('loading');
                $.get(TZAdmin.adminurl, {'tzaction': 'jscompress'}, function(rsp){
                    jrecompress.removeClass('loading');

                    rsp = $.trim(rsp);
                    if(rsp){
                        var json = rsp;
                        if(rsp.charAt(0) != '[' && rsp.charAt(0) != '{'){
                            json = rsp.match(/{.*?}/);
                            if(json && json[0]){
                                json = json[0];
                            }
                        }

                        if(json && typeof json == 'string'){
                            json = $.parseJSON(json);

                            if(json && (json.error || json.successful)){
                                TZAdmin.systemMessage(json.error || json.successful);
                            }
                        }
                    }
                });
                return false;
            });

			//for style toolbar
			$('#tz-toolbar-style-save-save').on('click', function(){
				Joomla.submitbutton('style.apply');
			});

			$('#tz-toolbar-style-save-close').on('click', function(){
				Joomla.submitbutton('style.save');
			});
			
			$('#tz-toolbar-style-save-clone').on('click', function(){
				Joomla.submitbutton('style.save2copy');
			});

			$('#tz-toolbar-close').on('click', function(){
				Joomla.submitbutton(($(this).hasClass('template') ? 'template' : 'style') + '.cancel');
			});
		},

		initRadioGroup: function(){
			//copy from J3.0
			// Turn radios into btn-group
			$('.radio.btn-group label').addClass('btn');
			$('.btn-group label').unbind('click').click(function() {
				var label = $(this),
					input = $('#' + label.attr('for'));

				if (!input.prop('checked')){
					label.closest('.btn-group')
						.find('label')
						.removeClass('active btn-success btn-danger btn-primary');

					label.addClass('active ' + (input.val() == '' ? 'btn-primary' : (input.val() == 0 ? 'btn-danger' : 'btn-success')));
					
					input.prop('checked', true).trigger('change.less');
				}

			});

			$('.btn-group input[checked=checked]').each(function(){
				if($(this).val() == ''){
					$('label[for=' + $(this).attr('id') + ']').addClass('active btn-primary');
				} else if($(this).val() == 0){
					$('label[for=' + $(this).attr('id') + ']').addClass('active btn-danger');
				} else {
					$('label[for=' + $(this).attr('id') + ']').addClass('active btn-success');
				}
			});
		},
		
		initChosen: function(){
			$('#style-form').find('select').chosen({
				disable_search_threshold : 10,
				allow_single_deselect : true
			});
		},

		initTZTitle: function(){
			var jptitle = $('.pagetitle');
			if (!jptitle.length) jptitle = $('.page-title');
			var titles = jptitle.html().split(':');

			jptitle.html(titles[0] + '<small>' + titles[1] + '</small>');
		},

		hideDisabled: function(){
			$('#style-form').find('[disabled="disabled"]').filter(function(){
				return this.name.match(/^.*?\[params\]\[(.*?)\]/)
			}).closest('.control-group').hide();
		},

		initPreSubmit: function(){

			var form = document.adminForm;
			if(!form){
				return false;
			}

			var onsubmit = form.onsubmit;

			form.onsubmit = function(e){
				var json = {},
					urlparts = form.action.split('#');
					
				if(/apply|save2copy/.test(form['task'].value)){
					tzactive = $('.tz-admin-nav .active a').attr('href').replace(/.*(?=#[^\s]*$)/, '').substr(1);

					if(urlparts[0].indexOf('?') == -1){
						urlparts[0] += '?tzlock=' + tzactive;
					} else {
						urlparts[0] += '&tzlock=' + tzactive;
					}
					
					form.action = urlparts.join('#');
				}
			};

			//clean the json code - the value is no need
			$('#jform_params_plazart_positions').val('');
		},

		initChangeStyle: function(){
			$('#tz-styles-list').on('change', function(){
				window.location.href = TZAdmin.baseurl + '/index.php?option=com_templates&task=style.edit&id=' + this.value;
			});
		},

		initCheckupdate: function(){
			
			var tinfo = $('#tpl-info dd'),
				finfo = $('#frmk-info dd');

			TZAdmin.chkupdating = null;
			TZAdmin.tplname = tinfo.eq(0).html();
			TZAdmin.tplversion = tinfo.eq(1).html();
			TZAdmin.frmkname = finfo.eq(0).html();
			TZAdmin.frmkversion = finfo.eq(1).html();
			
			$('#framework-home .updater, #template-home .updater').on('click', 'a.btn', function(){
				
				//if it is outdated, then we go direct to link
				if($(this).closest('.updater').hasClass('outdated')){
					return true;
				}

				//if we are checking, ignore this click, wait for it complete
				if(TZAdmin.chkupdating){
					return false;
				}

				//checking
				$(this).addClass('loading');
				TZAdmin.chkupdating = this;
				TZAdmin.checkUpdate();

				return false;
			});
		},

		checkUpdate: function(){
			$.ajax({
				url: TZAdmin.tzupdateurl,
				data: {eid: TZAdmin.eids},
				success: function(data) {
					var jfrmk = $('#framework-home .updater:first'),
						jtemp = $('#template-home .updater:first');

					jfrmk.find('.btn').removeClass('loading');
					jtemp.find('.btn').removeClass('loading');
					
					try {
						var ulist = $.parseJSON(data);
					} catch(e) {
						TZAdmin.alert(TZAdmin.langs.updateFailedGetList, TZAdmin.chkupdating);
					}

					if (ulist instanceof Array) {
						if (ulist.length > 0) {
							
							var	chkfrmk = !jfrmk.hasClass('outdated'),
								chktemp = !jtemp.hasClass('outdated');

							if(chkfrmk || chktemp){
								for(var i = 0, il = ulist.length; i < il; i++){

									if(chkfrmk && ulist[i].element == TZAdmin.felement && ulist[i].type == 'plugin'){
										jfrmk.addClass('outdated');
										jfrmk.find('.btn').attr('href', TZAdmin.jupdateUrl).html(TZAdmin.langs.updateDownLatest);
										jfrmk.find('h3').html(TZAdmin.langs.updateHasNew.replace(/%s/g, TZAdmin.frmkname));
										
										var ridx = 0,
											rvals = [TZAdmin.frmkversion, TZAdmin.frmkname, ulist[i].version];
										jfrmk.find('p').html(TZAdmin.langs.updateCompare.replace(/%s/g, function(){
											return rvals[ridx++];
										}));

										TZAdmin.langs.updateCompare.replace(/%s/g, function(){ return '' })
									}
									if(chktemp && ulist[i].element == TZAdmin.telement && ulist[i].type == 'template'){
										jtemp.addClass('outdated');
										jtemp.find('.btn').attr('href', TZAdmin.jupdateUrl).html(TZAdmin.langs.updateDownLatest);

										jtemp.find('h3').html(TZAdmin.langs.updateHasNew.replace(/%s/g, TZAdmin.tplname));
										
										var ridx = 0,
											rvals = [TZAdmin.tplversion, TZAdmin.tplname, ulist[i].version];
										jtemp.find('p').html(TZAdmin.langs.updateCompare.replace(/%s/g, function(){
											return rvals[ridx++];
										}));
									}
								}

								TZAdmin.alert(TZAdmin.langs.updateChkComplete, TZAdmin.chkupdating);
							}
						}
					} else {
						TZAdmin.alert(TZAdmin.langs.updateFailedGetList, TZAdmin.chkupdating);
					}

					TZAdmin.chkupdating = null;
				},
				error: function() {
					TZAdmin.alert(TZAdmin.langs.updateFailedGetList, TZAdmin.chkupdating);
					TZAdmin.chkupdating = null;
				}
			});
		},

		initSystemMessage: function(){
			var jmessage = $('#system-message');
				
			if(!jmessage.length){
				jmessage = $('' + 
					'<dl id="system-message">' +
						'<dt class="message">Message</dt>' +
						'<dd class="message">' +
							'<ul><li></li></ul>' +
						'</dd>' +
					'</dl>').hide().appendTo($('#system-message-container'));
			}

			TZAdmin.message = jmessage;
		},

		systemMessage: function(msg){
			TZAdmin.message.show();
			if(TZAdmin.message.find('li:first').length){
				TZAdmin.message.find('li:first').html(msg).show();
			} else {
				TZAdmin.message.html('' + 
					'<div class="alert">' +
						'<h4>Message</h4>' + 
						'<p>' + msg + '</p>' +
					'</div>');
			}
			
			clearTimeout(TZAdmin.msgid);
			TZAdmin.msgid = setTimeout(function(){
				TZAdmin.message.hide();
			}, 5000);
		},

		alert: function(msg, place){
			clearTimeout($(place).data('alertid'));
			$(place).after('' + 
				'<div class="alert">' +
					'<p>' + msg + '</p>' +
				'</div>').data('alertid', setTimeout(function(){
					$(place).nextAll('.alert').remove();
				}, 5000));
		},

		switchTab: function () {
			$('a[data-toggle="tab"]').on('shown', function (e) {
				var url = e.target.href;
			  	window.location.hash = url.substring(url.indexOf('#')).replace ('_params', '');
			});

			var hash = window.location.hash;
			if (hash) {
				$('a[href="' + hash + '_params' + '"]').tab ('show');
			} else {
				var url = $('ul.nav-tabs li.active a').attr('href');
				if (url) {
			  		window.location.hash = url.substring(url.indexOf('#')).replace ('_params', '');
				} else {
					$('ul.nav-tabs li:first a').tab ('show');
				}
			}
		},

		mergeurl: function(query, base){
			base = base || window.location.href;
			var urlparts = base.split('#');
			
			if(urlparts[0].indexOf('?') == -1){
				urlparts[0] += '?' + query;
			} else {
				urlparts[0] += '&' + query;
			}
			
			return urlparts.join('#');
		}

	});
	
	$(document).ready(function(){
		TZAdmin.initSystemMessage();
		TZAdmin.initTZTitle();
		TZAdmin.initBuildLessBtn();
		TZAdmin.initRadioGroup();
		TZAdmin.initChosen();
		TZAdmin.initPreSubmit();
		TZAdmin.hideDisabled();
		TZAdmin.initChangeStyle();
		//TZAdmin.initCheckupdate();
		TZAdmin.switchTab();
	});
	
}(window.$tz || window.jQuery);


!function($){

	var isdown = false,
		curelm = null,
		opts, memwidth, memfirst, memvisible, owidth, 
		mx, rzleft, rzwidth, rzlayout, rzindex, rzminspan,

		snapoffset = function(grid, size) {
			var limit = grid / 2;
			if ((size % grid) > limit) {
				return grid-(size % grid);
			} else {
				return -size % grid;
			}
		},

		spanfirst = function(rwidth){
			var sum = 0,
				needfirst = (memvisible[0] == 1);

			$(curelm).parent().children().each(function(idx){
				if(memvisible[idx] == 0 || memvisible[idx] == undefined){
					if(needfirst || ((sum + parseInt(memwidth[idx]) > TZAdmin.layout.maxgrid) || (rzindex + 1 == idx && sum + parseInt(memwidth[idx]) == TZAdmin.layout.maxgrid && (rwidth > owidth)))){
						$(this).addClass('spanfirst');
						memfirst[idx] = 1;
						sum = parseInt(memwidth[idx]);
						needfirst = false;
					} else {
						$(this).removeClass('spanfirst');
						memfirst[idx] = 0;
						sum += parseInt(memwidth[idx]);
					}
				}
			});
		},

		updatesize = function(e, togrid) {
			var mx = e.pageX,
				width = rwidth = (mx - rzleft + rzwidth);

			if(opts.grid){
				width = width + snapoffset(opts.grid, width) - opts.gap;
			}

			if(rwidth < opts.minwidth){
				rwidth = opts.minwidth;
			} else if (rwidth > opts.maxwidth){
				rwidth = opts.maxwidth;
			}

			if(width < opts.minwidth){
				width = opts.minwidth;
			} else if (width > opts.maxwidth){
				width = opts.maxwidth;
			}

			if(owidth != width){
				memwidth[rzindex] = rzminspan * ((width + opts.gap) / opts.grid) >> 0;
				owidth = width;

				$(curelm).find('.tz-layout-poswidth').html(memwidth[rzindex]);
			}

			curelm.style['width'] = (togrid ? width : rwidth) + 'px';

			spanfirst(rwidth);
		},

		updatecls = function(e){
			var mx = e.pageX,
				width = (mx - rzleft + rzwidth);

			if(opts.grid){
				width = width + snapoffset(opts.grid, width) - opts.gap;
			}

			if(width < opts.minwidth){
				width = opts.minwidth;
			} else if (width > opts.maxwidth){
				width = opts.maxwidth;
			}

			curelm.className = curelm.className.replace(/(\s*)span(\d+)(\s*)/g, ' ');
			$(curelm).css('width', '').addClass('span' + TZAdmin.tzwidthconvert((rzminspan * ((width + opts.gap) / opts.grid) >> 0)));

			spanfirst(width);
		},

		mousedown = function (e) {
			curelm = this.parentNode;
			isdown = true;
			rzleft = e.pageX;
			owidth = rzwidth  = $(curelm).width();

			var jdata = $(this).closest('.tz-layout-xresize');
			
			opts = jdata.data('rzdata');
			rzlayout = TZAdmin.layout.clayout;
			rzminspan = TZAdmin.layout.unitspan[rzlayout];
			rzindex = $(this).parent().index();
			memwidth = jdata.data('data-widths')[rzlayout];
			memfirst = jdata.data('data-firsts')[rzlayout];
			memvisible = jdata.data('data-vis').vals[rzlayout];

			updatesize(e);

			$(document)
			.on('mousemove.xresize', mousemove)
			.on('mouseup.xresize', mouseup);

			return false;
		},
		mousemove = function (e) {
			if(isdown) {
				updatesize(e);
				return false;
			}
		},
		mouseup = function (e) {
			isdown = false;
			updatecls(e);
			$(document).unbind('.xresize');
		};

	$.fn.xresize = function(opts) {
		return this.each(function () {
			$(opts.selector ? $(this).find(opts.selector) : this).append('<div class="tz-layout-rzhandle" title="' + TZAdmin.langs.layoutDragResize + '"></div>');			
			$(this)
			.addClass('tz-layout-xresize')
			.data('rzdata', $.extend({
				selector: '',
				minwidth: 0,
				maxwidth: 100000,
				minheight: 0,
				maxheight: 100000,
				grid: 0,
				gap: 0
			}, opts))
			.on('mousedown.wresize', '.tz-layout-rzhandle', mousedown);
		});
	};

}(window.$tz || window.jQuery);