<?php
/**
 * @package     Joomla.Administrator
 * @subpackage  com_templates
 *
 * @copyright   Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
?>

<link rel="stylesheet" href="<?php echo TZ_ADMIN_URL ?>/admin/tour/css/tztour.css" type="text/css" />
<script type="text/javascript" src="<?php echo TZ_URL ?>/js/jquery.ckie.js"></script>
<script type="text/javascript" src="<?php echo TZ_URL ?>/bootstrap/js/bootstrap-popover.js"></script>
<script type="text/javascript" src="<?php echo TZ_ADMIN_URL ?>/admin/tour/js/tztour.js"></script>


<div id="tz-tour-overlay" class="hide">
	<div class="tz-tour-overlay"></div>
	<div class="tz-tour-intro">
		<div class="tz-tour-intro-msg">
		    <h1>Welcome to tz!</h1>
		    <p>Are you ready to discover the best framework for Joomla! yet? Click the buttons below to start your travel and having fun!</p>
		</div>
		<div class="tz-tour-intro-action clearfix">
			<button class="tz-tour-starttour btn btn-large btn-primary pull-left"><i class="icon-signin"></i>Start the tour!</button>	
			<button class="tz-tour-endtour btn btn-large pull-right"><i class="icon-ok"></i>End</button>	
		</div>
	</div>	

	<div id="tz-tour-controls" class="tz-tour-controls clearfix">
		<div class="btn-group  pull-left">
			<button class="tz-tour-prevtourstep btn btn-primary"><i class="icon-caret-left"></i>Prev</button>	
			<button class="tz-tour-nexttourstep btn btn-primary">Next<i class="icon-caret-right" style="margin-left: 5px; margin-right: 0;"></i></button>
		</div>
		<button class="tz-tour-endtour btn pull-right"><i class="icon-ok"></i>End</button>	
		<div class="tz-tour-count"><span class="tz-tour-idx"></span>/<span class="tz-tour-total"></span></div>
	</div>
</div>

<script type="text/javascript">
	var tzTours = {};

	tzTours.tours = [
		{
			id		: '1',
			element : "#tz-toolbar-recompile",
			position: "bottom",
			highlighter: "", 
			monitor	: "",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_1_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_1_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>
		},
		{
			id		: '2',
			element : "#tz-toolbar-themer",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_2_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_2_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_2')) ?>
		},
		{
			id		: '3',
			element : "#tz_styles_list_chzn",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_3_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_3_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_3')) ?>
		},
		{
			id		: '4',
			element : "#jform_home_chzn",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_4_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_4_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_4')) ?>,
		},
		{
			id		: '5',
			element : "#template-home .updater",
			position: "left",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_5_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_5_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_4')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(0) a').tab ('show')}
		},
				{
			id		: '6',
			element : "#framework-home .updater",
			position: "left",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_6_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_6_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_4')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(0) a').tab ('show')}
		},
		{
			id		: '7',
			element : ".tz-admin-nav ul li:eq(1)",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_7_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_7_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(1) a').tab ('show')}
		},
		{
			id		: '8',
			element : "#jform_params_devmode label:first",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_8_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_8_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '9',
			element : "#jform_params_themermode label:first",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_9_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_9_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '10',
			element : "#jform_params_responsive label:first",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_10_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_10_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '11',
			element : ".tz-admin-nav ul li:eq(2)",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_11_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_11_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(2) a').tab ('show')}
		},
		{
			id		: '12',
			element : "#jform_params_theme_chzn",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_12_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_12_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '13',
			element : "#jform_params_logotype_chzn",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_13_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_13_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '14',
			element : ".tz-admin-nav ul li:eq(3)",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_14_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_14_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(3) a').tab ('show')}
		},
		{
			id		: '15',
			element : "#jform_params_mainlayout_chzn",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_15_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_15_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '16',
			element : ".mode-structure",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_21_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_21_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.mode-structure').trigger ('click')}
		},
				{
			id		: '17',
			element : ".tz-layout-mode-m",
			position: "right",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_20_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_20_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.tz-layout-mode-m').trigger ('click')}
		},
				{
			id		: '18',
			element : ".mode-layout",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_22_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_22_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.mode-layout').trigger ('click')}
		},
				{
			id		: '19',
			element : ".tz-layout-mode-r",
			position: "right",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_23_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_23_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '20',
			element : ".head-search .tz-layout-edit",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_16_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_16_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '21',
			element : ".tz-admin-nav ul li:eq(4)",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_17_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_17_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(4) a').tab ('show')}
		},
		{
			id		: '22',
			element : "#jform_params_mm_enable label:first",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_18_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_18_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
		},
		{
			id		: '23',
			element : ".tz-admin-nav ul li:eq(5)",
			position: "bottom",
			highlighter: "", 
			monitor	: "mouseover",
			title	: <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_19_TITLE')) ?>,
			text    : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_19_CONTENT')) ?>,
			dismiss : <?php echo json_encode(JText::_('TZ_TOUR_GUIDE_DISMISS_1')) ?>,
			beforeShow	: function() {jQuery('.tz-admin-nav ul li:eq(5) a').tab ('show')}
		}
	];


	tzTours.first = {
		tour: ["1", "2", "3", "4", "5", "6", "7", "11", "14", "23"],
		intro: <?php echo json_encode(JText::_('TZ_TOUR_INTRO_FIRST')) ?>
	}

	tzTours.plays = [
		{
			when: function() {return jQuery('.tz-admin-nav ul li:eq(1)').hasClass('active');},
			tour: ["8", "9", "10"],
			/*intro	: <?php echo json_encode(JText::_('TZ_TOUR_INTRO_TOUR1')) ?>*/
		},
		{
			when: function() {return jQuery('.tz-admin-nav ul li:eq(2)').hasClass('active');},
			tour: ["12", "13"],
			/*intro	: <?php echo json_encode(JText::_('TZ_TOUR_INTRO_TOUR2')) ?>*/
		},
		{
			when: function() {return jQuery('.tz-admin-nav ul li:eq(3)').hasClass('active');},
			tour: ["15", "16", "17", "18", "19"],
			/*intro	: <?php echo json_encode(JText::_('TZ_TOUR_INTRO_TOUR3')) ?>*/
		},
		{
			when: function() {return jQuery('.tz-admin-nav ul li:eq(4)').hasClass('active');},
			tour: ["19"],
			/*intro	: <?php echo json_encode(JText::_('TZ_TOUR_INTRO_TOUR4')) ?>*/
		},
		{
			when: function() {return jQuery('.tz-admin-nav ul li:eq(5)').hasClass('active');},
			tour: ["20"],
			/*intro	: <?php echo json_encode(JText::_('TZ_TOUR_INTRO_TOUR5')) ?>*/
		}
	];

	// init tours
	jQuery(document).ready(function($) {
		if(!tzTours.init){
			$.each(tzTours.tours, function(idx, tour){
				tour.title = tour.title.replace(/TZ_ADMIN_URL/g, TZAdmin.tzadminurl);
				tour.text = tour.text.replace(/TZ_ADMIN_URL/g, TZAdmin.tzadminurl);
			});
			$(document.body).tztour(tzTours);
			tzTours.init = true;
		}

		// integrate with help button
		$('#tz-toolbar-help').on('click', function(){
			if(typeof tzTours != 'undefined'){
				$(document.body).tztour('defaultTour');
			}
		});

	});
</script>