<?php
// Define constant

class tzAdmin {
	
	/**
	 * function render
	 * render tz administrator configuration form
	 *
	 * @return render success or not
	 */
	public function render(){
		$body = JResponse::getBody();
		$layout = TZ_ADMIN_PATH . '/admin/tpls/default.php';
		if(file_exists($layout) && JFactory::getApplication()->input->getCmd('view') == 'style'){
			ob_start();

			$this->loadParams();
			$buffer = ob_get_clean();

			$body = preg_replace('@<form\s[^>]*name="adminForm"[^>]*>?.*?</form>@siu', $buffer, $body);
		}

		$body = $this->replaceToolbar($body);
		$body = $this->replaceDoctype($body);

		JResponse::setBody($body);
	}

	public function addScripts(){
		// load template language
		JFactory::getLanguage()->load(TZ_PLUGIN, JPATH_ADMINISTRATOR);
		JFactory::getLanguage()->load ('tpl_'.TZ_TEMPLATE.'.sys', JPATH_ROOT, null, true);

		$langs = array(
			'lblCompile' => JText::_('TZ_LBL_RECOMPILE'),
			'lblThemer' => JText::_('TZ_LBL_VIEWTHEMER'),
			'enableThemeMagic' => JText::_('TZ_MSG_ENABLE_THEMEMAGIC'),
			
			'popoverLayoutTitle' => JText::_('TZ_LAYOUT_POPOVER_TITLE'),
			'popoverLayoutDesc' => JText::_('TZ_LAYOUT_POPOVER_DESC'),
			'popoverResponTitle' => JText::_('TZ_LAYOUT_RESPON_PTITLE'),
			'popoverResponDesc' => JText::_('TZ_LAYOUT_RESPON_PDESC'),
			'logoPresent' => JText::_('TZ_LAYOUT_LOGO_TEXT'),
			'emptyLayoutPosition' => JText::_('TZ_LAYOUT_EMPTY_POSITION'),
			'defaultLayoutPosition' => JText::_('TZ_LAYOUT_DEFAULT_POSITION'),
			
			'devideWide' => JText::_('TZ_LAYOUT_DVI_WIDE'),
			'devideNormal' => JText::_('TZ_LAYOUT_DVI_NORMAL'),
			'devideXTablet' => JText::_('TZ_LAYOUT_DVI_XTABLET'),
			'devideTablet' => JText::_('TZ_LAYOUT_DVI_TABLET'),
			'devideMobile' => JText::_('TZ_LAYOUT_DVI_MOBILE'),

			'displayModeStructure' => JText::_('TZ_LAYOUT_MODE_STRUCTURE'),
			'displayModeLayout' => JText::_('TZ_LAYOUT_MODE_LAYOUT'),

			'layoutResetAll' => JText::_('TZ_LAYOUT_RESET_ALL'),
			'layoutResetDevice' => JText::_('TZ_LAYOUT_RESET_PER_DEVICE'),
			'layoutResetPosition' => JText::_('TZ_LAYOUT_RESET_POSITION'),
			
			'layoutConfig' => JText::_('TZ_LAYOUT_CONFIG_TITLE'),
			'layoutConfigDesc' => JText::_('TZ_LAYOUT_CONFIG_DESC'),
			'layoutUnknownWidth' => JText::_('TZ_LAYOUT_UNKN_WIDTH'),
			'layoutPosWidth' => JText::_('TZ_LAYOUT_POS_WIDTH'),
			'layoutPosName' => JText::_('TZ_LAYOUT_POS_NAME'),

			'layoutCanNotLoad' => JText::_('TZ_LAYOUT_LOAD_ERROR'),

			'layoutEditPosition' => JText::_('TZ_LAYOUT_EDIT_POSITION'),
			'layoutShowPosition' => JText::_('TZ_LAYOUT_SHOW_POSITION'),
			'layoutHidePosition' => JText::_('TZ_LAYOUT_HIDE_POSITION'),
			'layoutChangeNumpos' => JText::_('TZ_LAYOUT_CHANGE_NUMPOS'),
			'layoutDragResize' => JText::_('TZ_LAYOUT_DRAG_RESIZE'),
			'layoutHiddenposDesc' => JText::_('TZ_LAYOUT_HIDDEN_POS_DESC'),
			
			'updateFailedGetList' => JText::_('TZ_OVERVIEW_FAILED_GETLIST'),
			'updateDownLatest' => JText::_('TZ_OVERVIEW_GO_DOWNLOAD'),
			'updateCheckUpdate' => JText::_('TZ_OVERVIEW_CHECK_UPDATE'),
			'updateChkComplete' => JText::_('TZ_OVERVIEW_CHK_UPDATE_OK'),
			'updateHasNew' => JText::_('TZ_OVERVIEW_TPL_NEW'),
			'updateCompare' => JText::_('TZ_OVERVIEW_TPL_COMPARE')
		);

		$params = new JRegistry;
		$db = JFactory::getDbo();

		//get params of templates
		$query = $db->getQuery(true);
		$query
			->select('params')
			->from('#__template_styles')
			->where('template='. $db->quote(TZ_TEMPLATE));
		
		$db->setQuery($query);
		$params->loadString($db->loadResult());

		//get extension id of framework and template
		$query = $db->getQuery(true);
		$query
			->select('extension_id')
			->from('#__extensions')
			->where('(element='. $db->quote(TZ_TEMPLATE) . ' AND type=' . $db->quote('template') . ') 
					OR (element=' . $db->quote(TZ_ADMIN) . ' AND type=' . $db->quote('plugin'). ')');

		$db->setQuery($query);
		$results = $db->loadRowList();
		$eids = array();
		foreach ($results as $eid) {
			$eids[] = $eid[0];
		}

		JFactory::getDocument()->addScriptDeclaration ( '
			var TZAdmin = window.TZAdmin || {};
			TZAdmin.adminurl = \'' . JFactory::getURI()->toString() . '\';
			TZAdmin.tzadminurl = \'' . TZ_ADMIN_URL . '\';
			TZAdmin.baseurl = \'' . JURI::base(true) . '\';			
			TZAdmin.template = \'' . TZ_TEMPLATE . '\';
			TZAdmin.langs = ' . json_encode($langs) . ';
			TZAdmin.devmode = ' . $params->get('devmode', 0) . ';
			TZAdmin.eids = [' . implode($eids, ',') .'];
			TZAdmin.telement = \'' . TZ_TEMPLATE . '\';
			TZAdmin.felement = \'' . TZ_ADMIN . '\';
			TZAdmin.themerUrl = \'' . JFactory::getURI()->toString() . '&tzaction=theme&tztask=thememagic' . '\';
			TZAdmin.tzupdateurl = \'' . JURI::base() . 'index.php?option=com_installer&view=update&task=update.atzx' . '\';
			TZAdmin.tzlayouturl = \'' . JURI::base() . 'index.php?tzaction=layout' . '\';
			TZAdmin.jupdateUrl = \'' . JURI::base() . 'index.php?option=com_installer&view=update' . '\';'
		);
	}
	
	/**
	 * function loadParam
	 * load and re-render parameters
	 *
	 * @return render success or not
	 */
	function loadParams(){
		$frwXml = TZ_ADMIN_PATH . '/'. TZ_ADMIN . '.xml';
		$tplXml = TZ_TEMPLATE_PATH . '/templateDetails.xml';
		$jtpl = TZ_ADMIN_PATH . '/admin/tpls/default.php';
        jimport('joomla.filesystem.folder');
        jimport('joomla.filesystem.file');
		
		if(file_exists($tplXml) && file_exists($jtpl)){
			
			//get the current joomla default instance
			$form = JForm::getInstance('com_templates.style', 'style', array('control' => 'jform', 'load_data' => true));
			
			//remove all fields from group 'params' and reload them again in right other base on template.xml
			$form->removeGroup('params');
			$form->loadFile(TZ_PATH . '/params/' . 'template.xml');
			$form->loadFile(TZ_TEMPLATE_PATH . DIRECTORY_SEPARATOR . 'templateDetails.xml', true, '//config');
			
			$xml = JFactory::getXML($tplXml);
			$fxml = JFactory::getXML($frwXml);

			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query
				->select('id, title')
				->from('#__template_styles')
				->where('template='. $db->quote(TZ_TEMPLATE));
			
			$db->setQuery($query);
			$styles = $db->loadObjectList();
			
			$session = JFactory::getSession();
			$tzlock = $session->get('tz.tzlock', 'overview_params');
			$session->set('tz.tzlock', null);
			$input = JFactory::getApplication()->input;

            $config_file    =   JFolder::files(TZ_TEMPLATE_PATH . DIRECTORY_SEPARATOR . 'config', '\.json$', false, false);
            $profiles   =   array();
            for ($i = 0; $i<count($config_file); $i++){
                $tmp        =    new stdClass();
                $tmp->value =   $config_file[$i];

                // Convert back slashes to forward slashes
                $slash = strrpos($tmp->value, '.');
                if ($slash !== false)
                {

                    $tmp->value= $tmp->text = substr($tmp->value,0, $slash);
                }
                else
                {

                    $tmp->text  =   $tmp->value;
                }
                $profiles[] =   $tmp;
            }

			include $jtpl;
			
			//search for global parameters
			$tzpp = JFactory::getApplication();
			$pglobals = array();
			foreach($form->getGroup('params') as $param){
				if($form->getFieldAttribute($param->fieldname, 'global', 0, 'params')){
					$pglobals[] = array('name' => $param->fieldname, 'value' => $form->getValue($param->fieldname, 'params')); 
				}
			}
			$tzpp->setUserState('oparams', $pglobals);

			return true;
		}
		
		return false;
	}

	function replaceToolbar($body){
		$tztoolbar = TZ_ADMIN_PATH . '/admin/tpls/toolbar.php';
		$input = JFactory::getApplication()->input;

		if(file_exists($tztoolbar) && class_exists('JToolBar')){
			//get the existing toolbar html
			jimport('joomla.language.help');
			$toolbar = JToolBar::getInstance('toolbar')->render('toolbar');
			$helpurl = JHelp::createURL($input->getCmd('view') == 'template' ? 'JHELP_EXTENSIONS_TEMPLATE_MANAGER_TEMPLATES_EDIT' : 'JHELP_EXTENSIONS_TEMPLATE_MANAGER_STYLES_EDIT');
			$helpurl = htmlspecialchars($helpurl, ENT_QUOTES);
		
			//render our toolbar
			ob_start();
			include $tztoolbar;
			$tztoolbar = ob_get_clean();

			//replace it
			$body = str_replace($toolbar, $tztoolbar, $body);
		}

		return $body;
	}

	function replaceDoctype($body){
		return preg_replace('@<!DOCTYPE\s(.*?)>@', '<!DOCTYPE html>', $body);
	}

    function configmanager() {
        jimport('joomla.filesystem.file');
        // necessary Joomla! classes
        $uri = JURI::getInstance();
        $db = JFactory::getDBO();
        // variables from URL
        $tpl_id = $uri->getVar('id', 'none');
        $task = $uri->getVar('tz_template_task', 'none');
        $file = JFilterOutput::stringURLSafe($uri->getVar('tz_template_file', 'none'));
        $base_path = TZ_TEMPLATE_PATH.DIRECTORY_SEPARATOR.'config'.DIRECTORY_SEPARATOR;

        // message
        $msg = '';
        // helping variables
        $redirectUrl = $uri->root() . 'administrator/index.php?option=com_templates&view=style&layout=edit&id=' . $tpl_id;
        // if the URL contains proper variables
        if($tpl_id !== 'none' && is_numeric($tpl_id) && $task !== 'none') {
            if($task == 'load') {
                $file   .=  '.json';

                if(JFile::exists($base_path . $file)) {
                    //
                    $query = '
						UPDATE
							#__template_styles
						SET
							params = '.$db->quote(file_get_contents($base_path . $file)).'
						WHERE
						 	id = '.$tpl_id.'
						LIMIT 1
						';
                    // Executing SQL Query
                    $db->setQuery($query);
                    $result = $db->query();
                    // check the result
                    if($result) {
                        // make an redirect
                        $app = JFactory::getApplication();
                        $app->redirect($redirectUrl, JText::_('TPL_TZ_LANG_CONFIG_LOADED_AND_SAVED'), 'message');
                    } else {
                        // make an redirect
                        $app = JFactory::getApplication();
                        $app->redirect($redirectUrl, JText::_('TPL_TZ_LANG_CONFIG_SQL_ERROR'), 'error');
                    }
                } else {
                    // make an redirect
                    $app = JFactory::getApplication();
                    $app->redirect($redirectUrl, JText::_('TPL_TZ_LANG_CONFIG_SELECTED_FILE_DOESNT_EXIST'), 'error');
                }
            } else if($task == 'save') {
                if($file == '') {
                    $file = date('d_m_Y_h_s');
                }
                // variable used to detect if the specified file exists
                $i = 0;
                // check if the file to save doesn't exist
                if(JFile::exists($base_path . $file . '.json')) {
                    // find the proper name for the file by incrementing
                    $i = 1;
                    while(JFile::exists($base_path . $file . $i . '.json')) { $i++; }
                }
                // get the settings from the database
                $query = '
					SELECT
						params AS params
					FROM
						#__template_styles
					WHERE
					 	id = '.$tpl_id.'
					LIMIT 1
					';
                // Executing SQL Query
                $db->setQuery($query);
                $row = $db->loadObject();
                // write it
                if(JFile::write($base_path . $file . (($i != 0) ? $i : '') . '.json' , $row->params)) {
                    // make an redirect
                    $app = JFactory::getApplication();
                    $app->redirect($redirectUrl, JText::_('TPL_TZ_LANG_CONFIG_FILE_SAVED_AS'). ' '. $file . (($i == 0) ? '' : $i) .'.json', 'message');
                } else {
                    // make an redirect
                    $app = JFactory::getApplication();
                    $app->redirect($redirectUrl, JText::_('TPL_TZ_LANG_CONFIG_FILE_WASNT_SAVED_PLEASE_CHECK_PERM'), 'error');
                }
            } else if($task == 'delete') {
                // Check if file exists before deleting
                $file .= '.json';
                if(JFile::exists($base_path . $file)) {
                    if(JFile::delete($base_path . $file)) {
                        $app = JFactory::getApplication();
                        $app->redirect($redirectUrl, $file . ' ' . JText::_('TPL_TZ_LANG_CONFIG_FILE_DELETED_AS'), 'message');
                    } else {
                        $app = JFactory::getApplication();
                        $app->redirect($redirectUrl, $file . ' ' . JText::_('TPL_TZ_LANG_CONFIG_FILE_WASNT_DELETED_PLEASE_CHECK_PERM'), 'error');
                    }
                } else {
                    $app = JFactory::getApplication();
                    $app->redirect($redirectUrl, $file . ' ' . JText::_('TPL_TZ_LANG_CONFIG_FILE_WASNT_DELETED_PLEASE_CHECK_FILE'), 'error');
                }
            }
        }
    }
}

?>