<?php

/**
 * ------------------------------------------------------------------------
 * TZ PLAZART System Plugin
 * ------------------------------------------------------------------------
 * Copyright (C) 2012-2013 SUNLAND Co., JSC. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: Sonle
 * Websites: http://www.templaza.com
 * ------------------------------------------------------------------------
 */
function tzimport($package)
{
	$path = TZ_ADMIN_PATH . DIRECTORY_SEPARATOR . 'includes' . DIRECTORY_SEPARATOR . strtolower($package) . '.php';
	if (file_exists($path)) {
        //var_dump($path); die();
		include_once $path;
	} else {
		trigger_error('tzimport not found object: ' . $package, E_USER_ERROR);
	}
}

/**
 * Plazart Class
 * Singleton class for tz
 */
class Plazart {
	
	protected static $tzapp = null;

	public static function getApp($tpl = null){
		if(empty(self::$tzapp)){	
			$tzpp = JFactory::getApplication();
			self::$tzapp = $tzpp->isAdmin() ? self::getAdmin() : self::getSite($tpl); 
		}
		
		return self::$tzapp;
	}

	/**
	 * Initialize tz
	 */
	public static function init () {
		// load core library
		tzimport ('core/path');
		
		$app = JFactory::getApplication();
		if (!$app->isAdmin()) {
			$jversion  = new JVersion;
			if($jversion->isCompatible('3.0')){
				// override core joomla class
				// JViewLegacy
				if (!class_exists('JViewLegacy', false)) tzimport ('joomla30/viewlegacy');
				// JModuleHelper
				if (!class_exists('JModuleHelper', false)) tzimport ('joomla30/modulehelper');
				// JPagination
				if (!class_exists('JPagination', false)) tzimport ('joomla30/pagination');
			} else {
				// do something funny
			}
		} else {
            // do something funny
		}
	}

	public static function getAdmin(){
		tzimport ('core/admin');
		return new tzAdmin();
	}

	public static function getSite($tpl){
        // do something funny
	}

	public static function cleanPath ($path) {
		$pattern = '/\w+\/\.\.\//';
		while(preg_match($pattern,$path)){
		    $path = preg_replace($pattern, '', $path);
		}
		return $path;		
	}

	public static function relativePath($path1, $path2='') {
		// absolute path
		if ($path2[0] == '/') return $path2;
		if ($path2 == '') {
		    $path2 = $path1;
		    $path1 = getcwd();
		}

		//Remove starting, ending, and double / in paths
		$path1 = trim($path1,'/');
		$path2 = trim($path2,'/');
		while (substr_count($path1, '//')) $path1 = str_replace('//', '/', $path1);
		while (substr_count($path2, '//')) $path2 = str_replace('//', '/', $path2);

		//create arrays
		$arr1 = explode('/', $path1);
		if ($arr1 == array('')) $arr1 = array();
		$arr2 = explode('/', $path2);
		if ($arr2 == array('')) $arr2 = array();
		$size1 = count($arr1);
		$size2 = count($arr2);

		//now the hard part :-p
		$path='';
		for($i=0; $i<min($size1,$size2); $i++)
		{
		    if ($arr1[$i] == $arr2[$i]) continue;
		    else $path = '../'.$path.$arr2[$i].'/';
		}
		if ($size1 > $size2)
		    for ($i = $size2; $i < $size1; $i++)
		        $path = '../'.$path;
		else if ($size2 > $size1)
		    for ($i = $size1; $i < $size2; $i++)
		        $path .= $arr2[$i].'/';

		return rtrim ($path, '/');
	}
}

Plazart::init();
?>