<?php
/**
 * ------------------------------------------------------------------------
 * TZ PLAZART System Plugin
 * ------------------------------------------------------------------------
 * Copyright (C) 2012-2013 SUNLAND Co., JSC. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: Sonle
 * Websites: http://www.templaza.com
 * ------------------------------------------------------------------------
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Joomla! P3P Header Plugin
 *
 * @package		Joomla.Plugin
 * @subpackage	System.p3p
 */

class plgSystemPlazart extends JPlugin
{
	//function onAfterInitialise(){
	function onAfterRoute(){
		include_once dirname(__FILE__) . '/includes/core/defines.php';
		$template = $this->detect();

		if($template){
			define ('TZ_TEMPLATE', $template);
			define ('TZ_TEMPLATE_URL', JURI::root(true).'/templates/'.TZ_TEMPLATE);
			define ('TZ_TEMPLATE_PATH', JPATH_ROOT .DIRECTORY_SEPARATOR. 'templates'. DIRECTORY_SEPARATOR . TZ_TEMPLATE);
			define ('TZ_TEMPLATE_REL', 'templates/' . TZ_TEMPLATE);

			$input = JFactory::getApplication()->input;

			if($input->getCmd('themer', 0)){
				define('TZ_THEMER', 1);
			}

			if($input->getCmd('tzlock', '')){
				JFactory::getSession()->set('tz.tzlock', $input->getCmd('tzlock', ''));
				$input->set('tzlock', null);
			}
			
			include_once dirname(__FILE__) . '/includes/core/plazart.php';
			
			if (!defined('TZ')){
				throw new Exception(JText::_('TZ_MSG_PACKAGE_DAMAGED'));
			}
			
			// excute action by tz
			if ($action = $input->getCmd ('tzaction')) {
				tzimport ('core/action');
				TZAction::run ($action);
			}
		}
	}

	function onBeforeRender(){
		if($this->detect()){
			$tzpp = JFactory::getApplication();
			$jdoc = JFactory::getDocument();
			if($tzpp->isAdmin()){
                $tzapp = Plazart::getApp();
                $tzapp->configmanager();

				//check for version compactible
				$jversion  = new JVersion;
				if(!$jversion->isCompatible('3.0')){
					$jdoc->addStyleSheet(TZ_ADMIN_URL . '/admin/bootstrap/css/bootstrap.css');
					
					$jdoc->addScript(TZ_ADMIN_URL . '/admin/js/jquery-1.8.0.min.js');
					$jdoc->addScript(TZ_ADMIN_URL . '/admin/bootstrap/js/bootstrap.js');
					$jdoc->addScript(TZ_ADMIN_URL . '/admin/js/jquery.noconflict.js');
				}

				$jdoc->addStyleSheet(TZ_ADMIN_URL . '/admin/plugins/chosen/chosen.css');
				$jdoc->addStyleSheet(TZ_ADMIN_URL . '/admin/css/tzadmin.css');
				if(!$jversion->isCompatible('3.0')){
					$jdoc->addStyleSheet(TZ_ADMIN_URL . '/admin/css/tzadmin-j25.css');
				} else {
					$jdoc->addStyleSheet(TZ_ADMIN_URL . '/admin/css/tzadmin-j30.css');
				}

				$jdoc->addScript(TZ_ADMIN_URL . '/admin/plugins/chosen/chosen.jquery.min.js');	

				$jdoc->addScript(TZ_ADMIN_URL . '/admin/js/json2.js');
				$jdoc->addScript(TZ_ADMIN_URL . '/admin/js/tzadmin.js');
                $jdoc->addScript(TZ_ADMIN_URL . '/admin/js/scripts.js');
				$tzapp->addScripts();
			} else {

			}
		}
	}
	
	function onBeforeCompileHead () {
		$app = JFactory::getApplication();
		if($this->detect() && !$app->isAdmin()){
			// call update head for replace css to less if in devmode
			$tzapp = Plazart::getApp();
			if($tzapp){

				$tzapp->updateHead();
			}
		}
	}

	function onAfterRender ()
	{
		$tzpp = JFactory::getApplication();
		if($tzpp->isAdmin()){
			if($this->detect()){
				$tzapp = Plazart::getApp();
				$tzapp->render();
			}
		} else {
            if($this->detect()){
                if (class_exists('TZRules')) {
                    $buf = TZRules::parseIt();
                    JResponse::setBody($buf);
                }
            }
        }
	}
	
	/**
     * Add TZ Extended menu parameter in administrator
     *
     * @param   JForm   $form   The form to be altered.
     * @param   array   $data   The associated data for the form
     *
     * @return  null
     */
	function onContentPrepareForm($form, $data)
	{
		// extra option for menu item
		/*if ($form->getName() == 'com_menus.item') {
			$this->loadLanguage();
			JForm::addFormPath(TZ_PATH . DIRECTORY_SEPARATOR . 'params');
			$form->loadFile('megaitem', false);

			$jversion = new JVersion;
			if(!$jversion->isCompatible('3.0')){
				$jdoc = JFactory::getDocument();
				$jdoc->addScript(TZ_ADMIN_URL . '/admin/js/jquery-1.8.0.min.js');
				$jdoc->addScript(TZ_ADMIN_URL . '/admin/js/jquery.noconflict.js');
			}

		} else 
		*/
		if($this->detect() && $form->getName() == 'com_templates.style'){
			$this->loadLanguage();
			JForm::addFormPath(TZ_PATH . DIRECTORY_SEPARATOR . 'params');
			$form->loadFile('template', false);
		}
	}
	
	function onExtensionAfterSave($option, $data){
		if($this->detect() && $option == 'com_templates.style' && !empty($data->id)){
			//get new params value
			$tzpp = JFactory::getApplication();
			$params = new JRegistry;
			$params->loadString($data->params);
			$oparams = $tzpp->getUserState('oparams');

			//check for changed params
			$pchanged = array();
			foreach($oparams as $oparam){
				if($params->get($oparam['name']) != $oparam['value']){
					$pchanged[] = $oparam['name'];
				}
			}

			//if we have any changed, we will update to global
			if(count($pchanged)){

				//get all other styles that have the same template
				$db = JFactory::getDBO();
				$query = $db->getQuery(true);
				$query
					->select('*')
					->from('#__template_styles')
					->where('template=' . $db->quote($data->template));

				$db->setQuery($query);
				$themes = $db->loadObjectList();
				
				//update all global parameters
				foreach($themes as $theme){
					$registry = new JRegistry;
					$registry->loadString($theme->params);

					foreach($pchanged as $pname){
						$registry->set($pname, $params->get($pname)); //overwrite with new value
					}

					$query = $db->getQuery(true);
					$query
						->update('#__template_styles')
						->set('params =' . $db->quote($registry->toString()))
						->where('id =' . (int)$theme->id)
						->where('id <>' . (int)$data->id);

					$db->setQuery($query);
					$db->query();
				}
			}

            // save profile
            $profile = JRequest::getString('config_manager_save_filename','');
            if (trim($profile)) {
                jimport('joomla.filesystem.file');
                $base_path = TZ_TEMPLATE_PATH.DIRECTORY_SEPARATOR.'config'.DIRECTORY_SEPARATOR;
                $file = JFilterOutput::stringURLSafe(trim($profile));
                // variable used to detect if the specified file exists
                $i = 0;
                // check if the file to save doesn't exist
                if(JFile::exists($base_path . $file . '.json')) {
                    // find the proper name for the file by incrementing
                    $i = 1;
                    while(JFile::exists($base_path . $file . $i . '.json')) { $i++; }
                }
                // get the settings from the database
                if (!JFile::write($base_path . $file . (($i != 0) ? $i : '') . '.json' , $data->params)){
                    JError::raiseNotice(403,'TPL_TZ_LANG_CONFIG_FILE_WASNT_SAVED_PLEASE_CHECK_PERM');
                }
            }
		}
	}

	function detect()
	{
		static $tz;

		if (!isset($tz)) {
			$tz = false; // set false
			$app = JFactory::getApplication();
			$input = JFactory::getApplication()->input;
			// get template name
			$tplname = '';
			if ($app->isAdmin()) {
				// if not login, do nothing
				$user = JFactory::getUser();
				if (!$user->id){
					return false;
				}

				if($tplname = $input->getCmd('tztemplate', '')){

				} else if($input->getCmd('option') == 'com_templates' && 
					(preg_match('/style\./', $input->getCmd('task')) || $input->getCmd('view') == 'style' || $input->getCmd('view') == 'template')
					){
					$db = JFactory::getDBO();
					$query = $db->getQuery(true);
					$id = $input->getInt('id');

					//when in POST the view parameter does not set
					if ($input->getCmd('view') == 'template') {						
						$query
						->select('element')
						->from('#__extensions')
						->where('extension_id='.(int)$id . ' AND type=' . $db->quote('template'));
					} else {
						$query
						->select('template')
						->from('#__template_styles')
						->where('id='.(int)$id);
					}

					$db->setQuery($query);
					$tplname = $db->loadResult();
				}

			} else {
				$tplname = $app->getTemplate(false);
			}

			if ($tplname) {				
					// parse xml
				$filePath = JPath::clean(JPATH_ROOT.'/templates/'.$tplname.'/templateDetails.xml');

				if (is_file ($filePath)) {
					$xml = JInstaller::parseXMLInstallFile($filePath);
					if (strtolower($xml['group']) == 'plazart') {
						$tz = $tplname;
					}
				}
			}

		}
		return $tz;
	}

    /**
     * Implement event onRenderModule to include the module chrome provide by T3
     * This event is fired by overriding ModuleHelper class
     * Return false for continueing render module
     *
     * @param   object  &$module   A module object.
     * @param   array   $attribs   An array of attributes for the module (probably from the XML).
     *
     * @return  bool
     */
    function onRenderModule (&$module, $attribs)
    {
    	static $chromed = false;
        // Detect layout path in T3 themes
    	if ($this->detect()) {
            // Chrome for module
    		if (!$chromed) {
    			$chromed = true;
                // We don't need chrome multi times
    			$chromePath = TZPath::getPath('html/modules.php');
    			if (file_exists($chromePath)) {
    				include_once $chromePath;
    			}
    		}
    	}
    	return false;
    }

    /**
     * Implement event onGetLayoutPath to return the layout which override by T3 & T3 templates
     * This event is fired by overriding ModuleHelper class
     * Return path to layout if found, false if not
     *
     * @param   string  $module  The name of the module
     * @param   string  $layout  The name of the module layout. If alternative
     *                           layout, in the form template:filename.
     *
     * @return  null
     */
    function onGetLayoutPath($module, $layout)
    {
        // Detect layout path in T3 themes
    	if ($this->detect()) {
    		$tPath = TZPath::getPath('html/' . $module . '/' . $layout . '.php');
    		if ($tPath)
    			return $tPath;
    	}
    	return false;
    }	
}
